#include "MultiDash.mqh"
MultiDash instances[];

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit() {
    ChartSetInteger(0, CHART_EVENT_MOUSE_MOVE, true);
    return(INIT_SUCCEEDED);
}

//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason) {
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnChartEvent(const int id, const long& lparam, const double& dparam, const string& sparam) {
    if(id == CHARTEVENT_CLICK && CanCreateDashboard((int)lparam, (int)dparam)) {
        MultiDash *instance = new MultiDash();
        instance.CreateRandom((int)lparam, (int)dparam, 50, 50);
        ArrayResize(instances, ArraySize(instances) + 1);
        instances[ArraySize(instances) - 1] = instance;
    }
    for(int i = 0; i < ArraySize(instances); i++) {
        instances[i].OnEvent(id, lparam, dparam, sparam);
    }
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool CanCreateDashboard(int X, int Y) {
    for(int i = 0; i < ArraySize(instances); i++) {
        if(instances[i].CheckCoordinate(X, Y)) return false;
    }
    return true;
}